<?php
/*
Plugin Name: RVVideos - RestoVisio's videos
Plugin URI: http://www.restovisio.com
Description: Converts RestoVisio URLs into Video embed codes
Version: 1.4
Author: Axel
Author URI: http://www.restovisio.com
*/


define('RVVIDEOS_REGEXP',	'~http://www\.restovisio\.com/restaurant/[a-z0-9_-]+-([0-9]+)\.htm~');
define('RVVIDEOS_WIDTH',	550);
define('RVVIDEOS_HEIGHT',	319);


/**
* Dynamically replaces RV URLs
* into the embedded video player
* on display only, not on save!
* Posts remain unchanged into 
* database !
**/
function rvvideos_plugin($content) {
	$width	= get_option('rvvideos_width');
	$height	= get_option('rvvideos_height');
	return preg_replace(RVVIDEOS_REGEXP, '<center><iframe width="'.$width.'" height="'.$height.'" border="0" frameborder="0" scrolling="no" src="http://www.restovisio.com/api/video/embed/$1?source=embed&autostart=no"></iframe></center>', $content);
}


/**
* Displaying the plugin
* option page with form
* !!! No HTML here !!! 
* Including external file 
* to keep code clean
**/
function rvvideos_option_page() {
	include 'html/admin-options.php';
}


/**
* Adding the plugin option
* page into admin menu
**/
function rvvideos_add_menu() {	
	add_options_page('RVVideos Plugin options', 'RVVideos plugin', 8, __FILE__, 'rvvideos_option_page'); 
}
 

/**
* When plugin is enabled
* Adding default options
**/ 
function activate_rvvideos() {
	add_option('rvvideos_width', RVVIDEOS_WIDTH);
	add_option('rvvideos_height', RVVIDEOS_HEIGHT);
}

/**
* When plugin is disabled
* Removing options
**/
function deactive_rvvideos() {
	delete_option('rvvideos_width', RVVIDEOS_WIDTH);
	delete_option('rvvideos_height', RVVIDEOS_HEIGHT);
}


/**
* Registers form fields
* When options are changed
**/
function rvvideos_admin_init() {
	register_setting('rvvideos_options', 'rvvideos_width', 'intval');
	register_setting('rvvideos_options', 'rvvideos_height', 'intval');
}


/**
* Hooks, filters and actions
**/
register_activation_hook(__FILE__,		'activate_rvvideos');
register_deactivation_hook(__FILE__,	'deactive_rvvideos');
add_action('admin_menu',				'rvvideos_add_menu'); 
add_action('admin_init',				'rvvideos_admin_init');
add_filter('the_content',				'rvvideos_plugin');
add_filter('the_content_rss',			'rvvideos_plugin');
add_filter('comment_text',				'rvvideos_plugin');
add_filter('the_excerpt',				'rvvideos_plugin');